#include "Triplet.h"

/*****************************************************************************/

Loop2d::Loop2d(Triplet<int> Bound)
  : Loop3d(Triplet<int>(0,0,0))

{ Bound.z=0;
}

Loop2d::Loop2d(Triplet<int> InitialValue,Triplet<int> Bound)
  : Loop3d(InitialValue,Bound)

{ z=0;
  pInitialValue.z=0;
  pBound.z=1;
}

/*****************************************************************************/

Loop3d::Loop3d(Triplet<int> Bound)
  : Triplet<int>(Triplet<int>(0,0,0))

{ pContinue=1;
  pInitialValue=Triplet<int>(0,0,0);
  pBound=Bound;
}
 
Loop3d::Loop3d(Triplet<int> InitialValue,Triplet<int> Bound)
  : Triplet<int>(InitialValue)

{ pContinue=1;
  pInitialValue=InitialValue;
  pBound=Bound;
}

Loop3d& Loop3d::operator ++(int)

{ x++;
  if (!(x<pBound.x))
    {
    y++;
    if(!(y<pBound.y))
      {
      z++;
      if(!(z<pBound.z))
	{
        pContinue=0;
        return (*this);
	}
      y=pInitialValue.y;
      }
    x=pInitialValue.x;
    }
  return (*this);
}

/*****************************************************************************/

#if defined(DYNAMICTEMPLATE)
#include "TripletTPL.h"
#endif
